/* eslint-disable react/no-unused-state */
import { Component } from "react";
import Taro from "@tarojs/taro";
import { ScrollView, View } from "@tarojs/components";
import { AddDiningPlate, CreateWeighOrder, GetWeighOrderByOpenId, UpdateWeighOrderStates,wechatPay } from '@/api/server'
import { goToPages, uShowToast } from "@/utils/index";
import "./index.scss";

interface ServerListDto {
    serviceList: serviceDto[],
    intervalId:any,
    openId: any,
    no:number,
    orderInfo: {
        goodsInfo:[],
        id:string,
        totalAmount:number,
        orderNumber:string
    },
    storeId: any,
}

interface serviceDto {
    orderId: any;
    chipCode: string,
    userName: string,
    code: string,
    goodsInfo: [],
    qrCode:string,
    isPay:boolean,
    no:string
}

export default class Index extends Component<
    any, ServerListDto
> {
    constructor(props) {
        super(props);
        this.state = {
            serviceList: [],
            intervalId:null,
            no:0,
            orderInfo: {
                goodsInfo:[],
                id:'',
                totalAmount:0,
                orderNumber:''
            },
            openId: Taro.getStorageSync('openId'),
            //openId: 'o4Uui64yhBNjfoyWpbCX7Q068VVs',
            storeId: '48e04c5e-5144-44d8-b087-465153884e64'
        };
    }
    componentDidMount() {
        Taro.hideHomeButton()
        this.GetQrcode()
        // 设置定时器
        setTimeout(() => {
            if (this.state.serviceList.length>0) {
                
                this.startInterval()
            }
        }, 2000);
    }
    startInterval = () => {
        console.log('开启轮询');
        this.GetQrcode()
        const intervalId = setInterval(() => {
            this.GetQrcode()
        }, 8000);
        this.setState({ intervalId });
      };
     
      stopInterval = () => {
        if (this.state.intervalId) {
          clearInterval(this.state.intervalId);
          this.setState({ intervalId: null});
        }
      };
    GetQrcode() {
        const jsonData = {
            openId: this.state.openId,
        }
        if (!this.state.openId) {
            uShowToast('openId未获取,重新获取')
            setTimeout(() => {
                goToPages('/pages/index/index',null,'reLaunch')
            }, 1500);
        }else{
        GetWeighOrderByOpenId(jsonData).then((res) => {
            console.log('获取当前订单', res);
            if (res.statusCode === 200) {
                res.data.diningPlateInfo.map((item)=>{
                    const p1 = item.qrCode.split("HK");
                    item.no = p1[1]
                    item.isPay=item.qrCode.includes("true")
                })
                const obj = JSON.parse(JSON.stringify(res.data.diningPlateInfo));
                this.setState({ serviceList: obj, orderInfo: res.data })
            }else{
                this.setState({ serviceList: [], orderInfo:{ goodsInfo:[],
                    id:'',
                    totalAmount:0
                ,orderNumber:''} })
            }
        })
    }
    }
    componentDidShow(options) {

    }

    onConfirmPayment = async (orderNumber,totalAmount) => {
        const orderCode = this.state.serviceList[0];
       
        
       if (totalAmount<=0) {
            UpdateWeighOrderStates({ orderId: this.state.orderInfo.id, payStates: 1, states: 1 }).then((res: any) => {
                if (res.statusCode === 200) {
                    this.stopInterval()
                    uShowToast('订单完成')
                }
                setTimeout(() => {
                    this.GetQrcode()
                }, 2000);
            })
        }
        else if (!orderCode.isPay) {
            Taro.showModal({
                title: '提示',
                content: '当前使用的免费餐盘,直接结算!',
                success:  (res)=> {
                if (res.confirm) {
                    UpdateWeighOrderStates({ orderId: this.state.orderInfo.id, payStates: 1, states: 1 }).then((res: any) => {
                        if (res.statusCode === 200) {
                            this.stopInterval()
                            uShowToast('订单完成')
                        }
                        setTimeout(() => {
                            this.GetQrcode()
                        }, 2000);
                    })
                } else if (res.cancel) {
                console.log('用户点击取消')
                }
            }
            })
        }
        else{
            wechatPay(orderNumber).then((res)=>{
                if (res.statusCode === 200) {
                    Taro.requestPayment(res.data)
                .then((success) => {
                //   this.paySuccess(res.data, params.hasHandRing);
                   
                     uShowToast('订单完成')
                     UpdateWeighOrderStates({ orderId: this.state.orderInfo.id, payStates: 1, states: 1 }).then((res: any) => {
                        if (res.statusCode === 200) {
                            this.stopInterval()
                            uShowToast('订单完成')
                        }
                        setTimeout(() => {
                            this.GetQrcode()
                        }, 2000);
                    })
                })
                .catch(() => {
                  uShowToast("支付未成功");
               
                });
                }
            })
        }
        }
    addPlate = async (code: any) => {
        try {
            const p1 = code.split("?");
            const p2 = p1[1].split("&");
            const p3 = p2[0].split("=");
            console.log(p2[0]);
            this.setState({no:p3[1]})
        if (!this.state.openId) {
            uShowToast('openId未获取,重新获取')
            setTimeout(() => {
                goToPages('/pages/index/index',null,'reLaunch')
            }, 1500);
        }
        if (this.state.serviceList.length <= 0) {
            CreateWeighOrder({
                qrCode: code,
                createId: this.state.openId,
            }).then((res) => {
                if (res.statusCode === 200) {
                  
                    this.startInterval()
                } else {
                    uShowToast(res.errors);
                }
            });
        } else {
           const isFalse = this.state.serviceList[0].qrCode.includes(p2[0]);
        //    console.log('isFalse',p2[0]);
        //    console.log('isFalse',this.state.serviceList[0].qrCode,isFalse);
           if (!isFalse) {
            uShowToast('免费餐盘和付费餐盘不能混用!');
            return;
           }
            AddDiningPlate({
                qrCode: code,
                orderId: this.state.serviceList[0].orderId
            }).then((res: any) => {
                if (res.statusCode === 200) {
                    this.GetQrcode()
                } else {
                    uShowToast(res.errors);
                }
            })
        }
    } catch (error) {
        uShowToast('请扫描正确的二维码!') 
        return;
    }
    }
    render() {
        const { serviceList, orderInfo } = this.state
        return (
            <View className='home'>
                <View className='top-box'>
                    海科欢迎您
                    <View className='down-box'>
                        <View className='tray-button tray-button-bg-saoyisao' onClick={() => {
                            Taro.scanCode({
                                success: (res) => {
                                    const qrCode = res.result;
                                    this.addPlate(qrCode)
                                }
                            })
                        }}>

                            <View>扫一扫</View>
                        </View>
                        <View className='tray-button tray-button-bg-order' onClick={() => {
                            goToPages(`/pages/tray/list/index`)
                        }}>

                            <View>我的订单</View>
                        </View>
                    </View>
                </View>
                <View className='center-box'>
                    <View className="down1-box">
                    <View className='tary-tuopan-title'>当前绑定托盘</View>
                   
                    <View className='tary-tuopan-title' onClick={()=>{
                       this.GetQrcode();
                    }}>当前状态:{this.state.intervalId?"自动监测":"手动刷新"}</View>
               
                    </View>
                    {/* 区域 */}
                    <ScrollView className="scroll" scrollY>
                    {serviceList.length <= 0 ?
                        <View className='tray-tuopan-box'>
                            <View className='tray-tuopan'>

                            </View>
                            <View className='tary-tuopan-remark'>当前未绑定托盘,请扫码绑定</View>
                        </View>
                        :
                        
                        serviceList.map((item, index) => (
                            <View key={index} className='service-plate-card'>
                                <View className='service-plate-item'>
                                    <View className='service-plate-left'>

                                    </View>
                                    <View className='service-plate-center'>
                                        <View className='service-plate-name'>
                                            No.{item.no}
                                        </View>
                                        <View className='service-plate-desc'>
                                            {item.userName}
                                        </View>

                                    </View>
                                    {/* <View className='service-plate-right' onClick={() => {
                                        goToPages(`/pages/tray/detail/index?orderid=${item.orderId}`)
                                    }}
                                    >
                                        详情
                                    </View> */}
                                </View>
                                <View className="service-plate-right">
                                    <View className='order-detail-container'>
                                        <View className='food-card'>

                                            <View className='food-list-card'>
                                                <View className='foot-list-item' >
                                                    <View className='food-item-name'>
                                                        商品名称
                                                    </View>
                                                    <View className='food-item-weight'>
                                                        重量(g)
                                                    </View>
                                                    <View className='food-item-price'>
                                                        单价
                                                    </View>
                                                    <View className='food-item-total'>
                                                        金额(元)
                                                    </View>
                                                </View>
                                                {item.goodsInfo ?
                                                    item.goodsInfo.map((item: any) => (
                                                        <View className='foot-list-item' >
                                                            <View className='food-item-name'>
                                                                {item.goodsName}
                                                            </View>
                                                            <View className='food-item-weight'>
                                                                {item.goodsWeight}
                                                            </View>
                                                            <View className='food-item-price'>
                                                                {item.price}
                                                            </View>
                                                            <View className='food-item-total'>
                                                                {item.totalAmount}
                                                            </View>
                                                        </View>
                                                    ))
                                                    : ""}

                                            </View>
                                        </View>


                                    </View>
                                </View>
                            </View>
                        ))
                    } 
                     
     </ScrollView>
                </View>
                
                <View>
                   {orderInfo.id ?  
                    <View className='payOrder'>
                        <View className='price'>
                            总价：￥
                            <View className='priceText'>
                                {orderInfo.totalAmount}
                            </View>
                        </View>
                        <View className='button' onClick={() => {
                            if (orderInfo) {
                                this.onConfirmPayment(orderInfo.orderNumber,orderInfo.totalAmount)
                            }
                        }} >
                            确认支付
                        </View>
                    </View>
                     :""}
                </View>
                {/* <View className='down-box'>
                    <View className='tray-button tray-button-bg-saoyisao' onClick={() => {
                        Taro.scanCode({
                            success: (res) => {
                                const qrCode = res.result;
                                this.addPlate(qrCode)
                            }
                        })
                    }}>

                        <View>扫一扫</View>
                    </View>
                    <View className='tray-button tray-button-bg-order' onClick={() => {
                        goToPages(`/pages/tray/list/index`)
                    }}>

                        <View>我的订单</View>
                    </View>
                </View> */}
            </View>
        );
    }
}
