import Taro from '@tarojs/taro';
import {getUserinfo} from '@/api/server'

export const getUserInfo = async () => {
  return new Promise<any>(async (resolve, reject) => {
    const userInfo = await getUserinfo();
    if (userInfo.statusCode = 200) {
      resolve(userInfo.data)
    } else {
      reject('网络连接中断,请尝试刷新小程序');
    }
  })
}
export const uShowToast = (title: string, icon?: 'success' | 'loading' | 'none') => {
  Taro.showToast({
    title,
    icon: icon || 'none',
    mask: true,
    duration: 3000,
  })
}

export const goToPages = (url, options?, type?: 'switchTab' | 'reLaunch' | 'redirectTo') => {
  if (false) {
    // wechatLogin().then(code => {
    //   login({ code: code }).then(res => {
    //     global.token = res.data;
    //     if (type) {
    //       switch (type) {
    //         case "switchTab":
    //           Taro.switchTab({ url })
    //           break;
    //         case "reLaunch":
    //           Taro.reLaunch({ url })
    //           break;
    //         case "redirectTo":
    //           Taro.redirectTo({ url })
    //           break;
    //       }
    //     } else {
    //       Taro.navigateTo({ url, ...options });
    //     }
    //   });
    // })
  } else {
    if (type) {
      switch (type) {
        case "switchTab":
          Taro.switchTab({ url })
          break;
        case "reLaunch":
          Taro.reLaunch({ url })
          break;
        case "redirectTo":
          Taro.redirectTo({ url })
          break;
      }
    } else {
      Taro.navigateTo({ url, ...options });
    }
  }
}
/**
 * 获取微信登录code
 */
export const wechatLogin = () => {
  return new Promise<string>(resolve => {
    Taro.login().then(res => {
      resolve(res.code)
    })
  })
}

/**
 * 是否是图片
 */
export const isImg=(url)=>{
  //获取最后一个.的位置
  var index = url.lastIndexOf(".")
  //获取后缀
  var ext = url.substring(index + 1) 
  // 进行判断
  return ['png', 'jpg', 'jpeg', 'bmp', 'gif', 'webp', 'psd', 'svg', 'tiff'].indexOf(ext.toLowerCase()) !== -1
}
/**
 * 计算下拉是否加载下一页
 * @param total
 * @param pageNum
 */
export const scrollToLower = (total, pageNo, pageSize = 10) => {
  return new Promise<{ pageNo: number, pageSize: number }>((resolve) => {
    // 计算当前有多少页数
    let pageTotal = Math.ceil(total / pageSize);

    // newpageNo 需要传递给后端的 pageNo
    let newPageNo = pageNo + 1
    // 如果 newpageNo 大于了当前的总页数，说明数据加载完毕
    console.log('1111',newPageNo,pageNo,pageTotal);
    
    if (newPageNo > pageTotal) {
      return false
    } else {
      resolve({
        pageNo: newPageNo,
        pageSize: pageSize
      })
    }
  })
}
